/* This is an autogenerated file from sme__build_signal_c.pl */
/* Tag: noCheckHeader */

/*    CONFIDENTIAL */
/*    Copyright (C) Cambridge Silicon Radio Ltd 2008. All rights reserved. */

#include "fsm/fsm.h" 
#include "hostio/hip_fsm_types.h"
#include "smeio/smeio_fsm_types.h"
#include "smeio/smeio_fsm_events.h"
#include "event_pack_unpack/event_pack_unpack.h"

uint16 build_packed_unifi_mgt_wifi_on_req(uint8** resultBuffer, const unifi_MACAddress* address, const unifi_DataBlockList* mibFiles)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 6;  address->data */
    /* packedSize += 2;  mibFiles->numElements */
    {
    int i;
    for (i = 0; i < mibFiles->numElements; i++)
    {
        packedSize += mibFiles->datalist[i].length + 2; /*lint !e725*/ /* unifi_DataBlock :: datalist */
        packedSize += 0;
    }
    }
    packedSize += 8; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_WIFI_ON_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_buffer(&buffer, (uint8*)&address->data, 6); /*lint !e545 !e725    data */
    packedLength += event_pack_uint16(&buffer, (uint16)mibFiles->numElements); /* numElements */
    {
    int i;
    for (i = 0; i < mibFiles->numElements; i++)
    {
        packedLength += event_pack_uint16(&buffer, mibFiles->datalist[i].length); /*lint !e725 unifi_DataBlock : datalist */
        packedLength += event_pack_buffer(&buffer, mibFiles->datalist[i].data, mibFiles->datalist[i].length); /*lint !e545 !e725 unifi_DataBlock : datalist */
    }
    }
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_wifi_off_req(uint8** resultBuffer)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_WIFI_OFF_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_wifi_flightmode_req(uint8** resultBuffer, const unifi_MACAddress* address, const unifi_DataBlockList* mibFiles)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 6;  address->data */
    /* packedSize += 2;  mibFiles->numElements */
    {
    int i;
    for (i = 0; i < mibFiles->numElements; i++)
    {
        packedSize += mibFiles->datalist[i].length + 2; /*lint !e725*/ /* unifi_DataBlock :: datalist */
        packedSize += 0;
    }
    }
    packedSize += 8; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_WIFI_FLIGHTMODE_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_buffer(&buffer, (uint8*)&address->data, 6); /*lint !e545 !e725    data */
    packedLength += event_pack_uint16(&buffer, (uint16)mibFiles->numElements); /* numElements */
    {
    int i;
    for (i = 0; i < mibFiles->numElements; i++)
    {
        packedLength += event_pack_uint16(&buffer, mibFiles->datalist[i].length); /*lint !e725 unifi_DataBlock : datalist */
        packedLength += event_pack_buffer(&buffer, mibFiles->datalist[i].data, mibFiles->datalist[i].length); /*lint !e545 !e725 unifi_DataBlock : datalist */
    }
    }
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_set_value_req(uint8** resultBuffer, const unifi_AppValue* appValue)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  appValue->id */
    /* -----------------------------------------------------------------*/
    /* A UNION  :: unifi_Value_union*/
    /* -----------------------------------------------------------------*/
    switch(appValue->id)
    {
    case unifi_AdHocConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.adHocConfig.atimWindow */
        /* packedSize += 2;  appValue->unifi_Value_union.adHocConfig.beaconPeriod */
        /* packedSize += 1;  appValue->unifi_Value_union.adHocConfig.defaultChannelNumber */
        packedSize += 5; /* Size of Fixed elements */
        break;
    case unifi_CalibrationDataValue:
        packedSize += appValue->unifi_Value_union.calibrationData.length + 2; /*lint !e725*/ /* unifi_DataBlock :: calibrationData */
        break;
    case unifi_CoexConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexEnable */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexAfhChannelEnable */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexAdvancedEnable */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexEnableSchemeManagement */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexDirection */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexPeriodicWakeHost */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexTrafficBurstyLatencyMs */
        /* packedSize += 2;  appValue->unifi_Value_union.coexConfig.coexTrafficContinuousLatencyMs */
        packedSize += 16; /* Size of Fixed elements */
        break;
    case unifi_CoexInfoValue:
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.hasTrafficData */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentTrafficType */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentPeriod */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentPowerSave */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentCoexPeriod */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentCoexLatency */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.hasBtDevice */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.mibValuesSet */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputOffset */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputDuration */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputPeriod */
        /* packedSize += 2;  appValue->unifi_Value_union.coexInfo.currentCoexScheme */
        packedSize += 24; /* Size of Fixed elements */
        break;
    case unifi_ConnectionConfigValue:
        /* packedSize += 32;  appValue->unifi_Value_union.connectionConfig.ssid.ssid */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionConfig.ssid.length */
        /* packedSize += 6;  appValue->unifi_Value_union.connectionConfig.bssid.data */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionConfig.bssType */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionConfig.privacyMode */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionConfig.authMode */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionConfig.encryptionMode */
        packedSize += appValue->unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length + 2; /*lint !e725*/ /* unifi_DataBlock :: mlmeAssociateReqInformationElements */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionConfig.wmmQosInfo */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionConfig.adhocChannel */
        packedSize += 49; /* Size of Fixed elements */
        break;
    case unifi_ConnectionInfoValue:
        /* packedSize += 32;  appValue->unifi_Value_union.connectionInfo.ssid.ssid */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionInfo.ssid.length */
        /* packedSize += 6;  appValue->unifi_Value_union.connectionInfo.bssid.data */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.networkType80211 */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionInfo.channelNumber */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.channelFrequency */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.authMode */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.ifIndex */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.atimWindow */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.beaconPeriod */
        packedSize += appValue->unifi_Value_union.connectionInfo.assocScanInfoElements.length + 2; /*lint !e725*/ /* unifi_DataBlock :: assocScanInfoElements */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.assocReqCapabilities */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.assocReqListenInterval */
        /* packedSize += 6;  appValue->unifi_Value_union.connectionInfo.assocReqApAddress.data */
        packedSize += appValue->unifi_Value_union.connectionInfo.assocReqInfoElements.length + 2; /*lint !e725*/ /* unifi_DataBlock :: assocReqInfoElements */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.assocRspResult */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.assocRspCapabilityInfo */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionInfo.assocRspAssociationId */
        packedSize += appValue->unifi_Value_union.connectionInfo.assocRspInfoElements.length + 2; /*lint !e725*/ /* unifi_DataBlock :: assocRspInfoElements */
        packedSize += 68; /* Size of Fixed elements */
        break;
    case unifi_ConnectionStatsValue:
        /* packedSize += 2;  appValue->unifi_Value_union.connectionStats.unifiRSSI */
        /* packedSize += 2;  appValue->unifi_Value_union.connectionStats.unifiSNR */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionStats.unifiTxDataRate */
        /* packedSize += 1;  appValue->unifi_Value_union.connectionStats.unifiRxDataRate */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11RetryCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11MultipleRetryCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11ACKFailureCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11FrameDuplicateCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11FCSErrorCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11RTSSuccessCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11RTSFailureCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11ReceivedFragmentCount */
        /* packedSize += 4;  appValue->unifi_Value_union.connectionStats.dot11TransmittedFragmentCount */
        packedSize += 42; /* Size of Fixed elements */
        break;
    case unifi_HostConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.hostConfig.powerMode */
        /* packedSize += 2;  appValue->unifi_Value_union.hostConfig.applicationDataPeriodMs */
        packedSize += 4; /* Size of Fixed elements */
        break;
    case unifi_MIBConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.mibConfig.unifiFixMaxTxDataRate */
        /* packedSize += 1;  appValue->unifi_Value_union.mibConfig.unifiFixTxDataRate */
        /* packedSize += 2;  appValue->unifi_Value_union.mibConfig.dot11RTSThreshold */
        /* packedSize += 2;  appValue->unifi_Value_union.mibConfig.dot11FragmentationThreshold */
        /* packedSize += 2;  appValue->unifi_Value_union.mibConfig.dot11CurrentTxPowerLevel */
        packedSize += 9; /* Size of Fixed elements */
        break;
    case unifi_PermanentMacAddressValue:
        /* packedSize += 6;  appValue->unifi_Value_union.permanentMacAddress.data */
        packedSize += 6; /* Size of Fixed elements */
        break;
    case unifi_PowerConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.powerConfig.powerSaveLevel */
        /* packedSize += 2;  appValue->unifi_Value_union.powerConfig.listenInterval */
        /* packedSize += 2;  appValue->unifi_Value_union.powerConfig.rxDtims */
        /* packedSize += 2;  appValue->unifi_Value_union.powerConfig.d3autoScanMode */
        packedSize += 8; /* Size of Fixed elements */
        break;
    case unifi_RoamingConfigValue:
        /* packedSize += 66;  appValue->unifi_Value_union.roamingConfig.roamingBands */
        /* packedSize += 1;  appValue->unifi_Value_union.roamingConfig.lowQualHystWindow */
        /* packedSize += 1;  appValue->unifi_Value_union.roamingConfig.apBlockTime */
        /* packedSize += 1;  appValue->unifi_Value_union.roamingConfig.roamMonitorPeriod */
        /* packedSize += 1;  appValue->unifi_Value_union.roamingConfig.roamNumMaxTh */
        packedSize += 70; /* Size of Fixed elements */
        break;
    case unifi_SMEConfigValue:
        /* packedSize += 2;  appValue->unifi_Value_union.smeConfig.enablePmkidCanditateListIndications */
        /* packedSize += 1;  appValue->unifi_Value_union.smeConfig.connectionQualityRssiChangeTrigger */
        /* packedSize += 1;  appValue->unifi_Value_union.smeConfig.connectionQualitySnrChangeTrigger */
        /* packedSize += 2;  appValue->unifi_Value_union.smeConfig.trustLevel */
        /* packedSize += 2;  appValue->unifi_Value_union.smeConfig.countryCode */
        /* packedSize += 2;  appValue->unifi_Value_union.smeConfig.wmmMode */
        /* packedSize += 2;  appValue->unifi_Value_union.smeConfig.ifIndex */
        packedSize += 12; /* Size of Fixed elements */
        break;
    case unifi_ScanConfigValue:
        /* packedSize += 48;  appValue->unifi_Value_union.scanControl.scanCfg */
        /* packedSize += 2;  appValue->unifi_Value_union.scanControl.enableIndications */
        /* packedSize += 2;  appValue->unifi_Value_union.scanControl.maxResults */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.highRSSIThreshold */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.lowRSSIThreshold */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.deltaRSSIThreshold */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.highSNRThreshold */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.lowSNRThreshold */
        /* packedSize += 1;  appValue->unifi_Value_union.scanControl.deltaSNRThreshold */
        packedSize += appValue->unifi_Value_union.scanControl.passiveChannelList.length + 2; /*lint !e725*/ /* unifi_DataBlock :: passiveChannelList */
        packedSize += 58; /* Size of Fixed elements */
        break;
    case unifi_StationMacAddressValue:
        /* packedSize += 6;  appValue->unifi_Value_union.stationMacAddress.data */
        packedSize += 6; /* Size of Fixed elements */
        break;
    case unifi_VersionsValue:
        /* packedSize += 4;  appValue->unifi_Value_union.versions.chipId */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.chipVersion */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.firmwareBuild */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.firmwareHip */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.driverBuild */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.driverHip */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.driverApi */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.smeBuild */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.smeVariant */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.smeDriverApi */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.smeHip */
        /* packedSize += 4;  appValue->unifi_Value_union.versions.smeSapApi */
        packedSize += (uint16)osa_strlen(appValue->unifi_Value_union.versions.smeIdString) + 3; /* unifi_String :: smeIdString */
        packedSize += 48; /* Size of Fixed elements */
        break;
    default:
        break;
    }
    /* -----------------------------------------------------------------*/
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_SET_VALUE_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)appValue->id); /* id */
    /* -----------------------------------------------------------------*/
    /* A UNION  :: unifi_Value_union*/
    /* -----------------------------------------------------------------*/
    switch(appValue->id)
    {
    case unifi_AdHocConfigValue:
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.adHocConfig.atimWindow); /* atimWindow */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.adHocConfig.beaconPeriod); /* beaconPeriod */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.adHocConfig.defaultChannelNumber, 1); /*lint !e545 !e725    defaultChannelNumber */
        break;
    case unifi_CalibrationDataValue:
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.calibrationData.length); /*lint !e725 unifi_DataBlock : calibrationData */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.calibrationData.data, appValue->unifi_Value_union.calibrationData.length); /*lint !e545 !e725 unifi_DataBlock : calibrationData */
        break;
    case unifi_CoexConfigValue:
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexConfig.coexEnable); /* coexEnable */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexConfig.coexAfhChannelEnable); /* coexAfhChannelEnable */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexConfig.coexAdvancedEnable); /* coexAdvancedEnable */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexConfig.coexEnableSchemeManagement); /* coexEnableSchemeManagement */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexConfig.coexDirection); /* coexDirection */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexConfig.coexPeriodicWakeHost); /* coexPeriodicWakeHost */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexConfig.coexTrafficBurstyLatencyMs); /* coexTrafficBurstyLatencyMs */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexConfig.coexTrafficContinuousLatencyMs); /* coexTrafficContinuousLatencyMs */
        break;
    case unifi_CoexInfoValue:
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexInfo.hasTrafficData); /* hasTrafficData */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentTrafficType); /* currentTrafficType */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentPeriod); /* currentPeriod */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentPowerSave); /* currentPowerSave */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentCoexPeriod); /* currentCoexPeriod */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentCoexLatency); /* currentCoexLatency */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexInfo.hasBtDevice); /* hasBtDevice */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.coexInfo.mibValuesSet); /* mibValuesSet */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputOffset); /* currentPeriodicPIOInputOffset */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputDuration); /* currentPeriodicPIOInputDuration */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentPeriodicPIOInputPeriod); /* currentPeriodicPIOInputPeriod */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.coexInfo.currentCoexScheme); /* currentCoexScheme */
        break;
    case unifi_ConnectionConfigValue:
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionConfig.ssid.ssid, 32); /*lint !e545 !e725    ssid */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionConfig.ssid.length, 1); /*lint !e545 !e725    length */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionConfig.bssid.data, 6); /*lint !e545 !e725    data */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionConfig.bssType); /* bssType */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionConfig.privacyMode); /* privacyMode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionConfig.authMode); /* authMode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionConfig.encryptionMode); /* encryptionMode */
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length); /*lint !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.data, appValue->unifi_Value_union.connectionConfig.mlmeAssociateReqInformationElements.length); /*lint !e545 !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionConfig.wmmQosInfo, 1); /*lint !e545 !e725    wmmQosInfo */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionConfig.adhocChannel, 1); /*lint !e545 !e725    adhocChannel */
        break;
    case unifi_ConnectionInfoValue:
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionInfo.ssid.ssid, 32); /*lint !e545 !e725    ssid */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionInfo.ssid.length, 1); /*lint !e545 !e725    length */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionInfo.bssid.data, 6); /*lint !e545 !e725    data */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.networkType80211); /* networkType80211 */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionInfo.channelNumber, 1); /*lint !e545 !e725    channelNumber */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.channelFrequency); /* channelFrequency */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.authMode); /* authMode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.ifIndex); /* ifIndex */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.atimWindow); /* atimWindow */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.beaconPeriod); /* beaconPeriod */
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.connectionInfo.assocScanInfoElements.length); /*lint !e725 unifi_DataBlock : assocScanInfoElements */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.connectionInfo.assocScanInfoElements.data, appValue->unifi_Value_union.connectionInfo.assocScanInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocScanInfoElements */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.assocReqCapabilities); /* assocReqCapabilities */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.assocReqListenInterval); /* assocReqListenInterval */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionInfo.assocReqApAddress.data, 6); /*lint !e545 !e725    data */
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.connectionInfo.assocReqInfoElements.length); /*lint !e725 unifi_DataBlock : assocReqInfoElements */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.connectionInfo.assocReqInfoElements.data, appValue->unifi_Value_union.connectionInfo.assocReqInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocReqInfoElements */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.assocRspResult); /* assocRspResult */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.assocRspCapabilityInfo); /* assocRspCapabilityInfo */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.connectionInfo.assocRspAssociationId); /* assocRspAssociationId */
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.connectionInfo.assocRspInfoElements.length); /*lint !e725 unifi_DataBlock : assocRspInfoElements */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.connectionInfo.assocRspInfoElements.data, appValue->unifi_Value_union.connectionInfo.assocRspInfoElements.length); /*lint !e545 !e725 unifi_DataBlock : assocRspInfoElements */
        break;
    case unifi_ConnectionStatsValue:
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.connectionStats.unifiRSSI); /* unifiRSSI */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.connectionStats.unifiSNR); /* unifiSNR */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionStats.unifiTxDataRate, 1); /*lint !e545 !e725    unifiTxDataRate */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.connectionStats.unifiRxDataRate, 1); /*lint !e545 !e725    unifiRxDataRate */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11RetryCount); /* dot11RetryCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11MultipleRetryCount); /* dot11MultipleRetryCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11ACKFailureCount); /* dot11ACKFailureCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11FrameDuplicateCount); /* dot11FrameDuplicateCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11FCSErrorCount); /* dot11FCSErrorCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11RTSSuccessCount); /* dot11RTSSuccessCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11RTSFailureCount); /* dot11RTSFailureCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11ReceivedFragmentCount); /* dot11ReceivedFragmentCount */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.connectionStats.dot11TransmittedFragmentCount); /* dot11TransmittedFragmentCount */
        break;
    case unifi_HostConfigValue:
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.hostConfig.powerMode); /* powerMode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.hostConfig.applicationDataPeriodMs); /* applicationDataPeriodMs */
        break;
    case unifi_MIBConfigValue:
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.mibConfig.unifiFixMaxTxDataRate); /* unifiFixMaxTxDataRate */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.mibConfig.unifiFixTxDataRate, 1); /*lint !e545 !e725    unifiFixTxDataRate */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.mibConfig.dot11RTSThreshold); /* dot11RTSThreshold */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.mibConfig.dot11FragmentationThreshold); /* dot11FragmentationThreshold */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.mibConfig.dot11CurrentTxPowerLevel); /* dot11CurrentTxPowerLevel */
        break;
    case unifi_PermanentMacAddressValue:
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.permanentMacAddress.data, 6); /*lint !e545 !e725    data */
        break;
    case unifi_PowerConfigValue:
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.powerConfig.powerSaveLevel); /* powerSaveLevel */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.powerConfig.listenInterval); /* listenInterval */
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.powerConfig.rxDtims); /* rxDtims */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.powerConfig.d3autoScanMode); /* d3autoScanMode */
        break;
    case unifi_RoamingConfigValue:
        {
        int i;
        for (i = 0; i < 3; i++)
        {
            packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.roamingConfig.roamingBands[i].rssiHighThreshold); /* rssiHighThreshold */
            packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.roamingConfig.roamingBands[i].rssiLowThreshold); /* rssiLowThreshold */
            packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.roamingConfig.roamingBands[i].snrHighThreshold); /* snrHighThreshold */
            packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.roamingConfig.roamingBands[i].snrLowThreshold); /* snrLowThreshold */
            packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.roamingConfig.roamingBands[i].monitorInterval); /* monitorInterval */
            packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.roamingConfig.roamingBands[i].monitorWindow); /* monitorWindow */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].dot11RetryRatio, 1); /*lint !e545 !e725    dot11RetryRatio */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].dot11MultipleRetryRatio, 1); /*lint !e545 !e725    dot11MultipleRetryRatio */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].dot11ACKFailureRatio, 1); /*lint !e545 !e725    dot11ACKFailureRatio */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].dot11FCSErrorRatio, 1); /*lint !e545 !e725    dot11FCSErrorRatio */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].dot11RTSFailureRatio, 1); /*lint !e545 !e725    dot11RTSFailureRatio */
            packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamingBands[i].beaconLossThreshold, 1); /*lint !e545 !e725    beaconLossThreshold */
        }
        }
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.lowQualHystWindow, 1); /*lint !e545 !e725    lowQualHystWindow */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.apBlockTime, 1); /*lint !e545 !e725    apBlockTime */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamMonitorPeriod, 1); /*lint !e545 !e725    roamMonitorPeriod */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.roamingConfig.roamNumMaxTh, 1); /*lint !e545 !e725    roamNumMaxTh */
        break;
    case unifi_SMEConfigValue:
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.smeConfig.enablePmkidCanditateListIndications); /* enablePmkidCanditateListIndications */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.smeConfig.connectionQualityRssiChangeTrigger, 1); /*lint !e545 !e725    connectionQualityRssiChangeTrigger */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.smeConfig.connectionQualitySnrChangeTrigger, 1); /*lint !e545 !e725    connectionQualitySnrChangeTrigger */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.smeConfig.trustLevel); /* trustLevel */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.smeConfig.countryCode, 2); /*lint !e545 !e725    countryCode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.smeConfig.wmmMode); /* wmmMode */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.smeConfig.ifIndex); /* ifIndex */
        break;
    case unifi_ScanConfigValue:
        {
        int i;
        for (i = 0; i < 4; i++)
        {
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].interval); /* interval */
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].validity); /* validity */
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].minActiveChannelTime); /* minActiveChannelTime */
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].maxActiveChannelTime); /* maxActiveChannelTime */
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].minPassiveChannelTime); /* minPassiveChannelTime */
            packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.scanCfg[i].maxPassiveChannelTime); /* maxPassiveChannelTime */
        }
        }
        packedLength += event_pack_int16(&buffer, (int16)appValue->unifi_Value_union.scanControl.enableIndications); /* enableIndications */
        packedLength += event_pack_uint16(&buffer, (uint16)appValue->unifi_Value_union.scanControl.maxResults); /* maxResults */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.highRSSIThreshold, 1); /*lint !e545 !e725    highRSSIThreshold */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.lowRSSIThreshold, 1); /*lint !e545 !e725    lowRSSIThreshold */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.deltaRSSIThreshold, 1); /*lint !e545 !e725    deltaRSSIThreshold */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.highSNRThreshold, 1); /*lint !e545 !e725    highSNRThreshold */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.lowSNRThreshold, 1); /*lint !e545 !e725    lowSNRThreshold */
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.scanControl.deltaSNRThreshold, 1); /*lint !e545 !e725    deltaSNRThreshold */
        packedLength += event_pack_uint16(&buffer, appValue->unifi_Value_union.scanControl.passiveChannelList.length); /*lint !e725 unifi_DataBlock : passiveChannelList */
        packedLength += event_pack_buffer(&buffer, appValue->unifi_Value_union.scanControl.passiveChannelList.data, appValue->unifi_Value_union.scanControl.passiveChannelList.length); /*lint !e545 !e725 unifi_DataBlock : passiveChannelList */
        break;
    case unifi_StationMacAddressValue:
        packedLength += event_pack_buffer(&buffer, (uint8*)&appValue->unifi_Value_union.stationMacAddress.data, 6); /*lint !e545 !e725    data */
        break;
    case unifi_VersionsValue:
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.chipId); /* chipId */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.chipVersion); /* chipVersion */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.firmwareBuild); /* firmwareBuild */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.firmwareHip); /* firmwareHip */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.driverBuild); /* driverBuild */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.driverHip); /* driverHip */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.driverApi); /* driverApi */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.smeBuild); /* smeBuild */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.smeVariant); /* smeVariant */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.smeDriverApi); /* smeDriverApi */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.smeHip); /* smeHip */
        packedLength += event_pack_uint32(&buffer, (uint32)appValue->unifi_Value_union.versions.smeSapApi); /* smeSapApi */
        packedLength += event_pack_string(&buffer, appValue->unifi_Value_union.versions.smeIdString); /* unifi_String : smeIdString */
        break;
    default:
        break;
    }
    /* -----------------------------------------------------------------*/
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_get_value_req(uint8** resultBuffer, unifi_AppValueId appValueId)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  appValueId */
    packedSize += 2; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_GET_VALUE_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)appValueId); /* appValueId */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_mib_set_req(uint8** resultBuffer, const unifi_DataBlock* mibAttribute)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    packedSize += mibAttribute->length + 2; /*lint !e725*/ /* unifi_DataBlock :: mibAttribute */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_MIB_SET_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, mibAttribute->length); /*lint !e725 unifi_DataBlock : mibAttribute */
    packedLength += event_pack_buffer(&buffer, mibAttribute->data, mibAttribute->length); /*lint !e545 !e725 unifi_DataBlock : mibAttribute */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_mib_get_req(uint8** resultBuffer, const unifi_DataBlock* mibAttribute)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    packedSize += mibAttribute->length + 2; /*lint !e725*/ /* unifi_DataBlock :: mibAttribute */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_MIB_GET_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, mibAttribute->length); /*lint !e725 unifi_DataBlock : mibAttribute */
    packedLength += event_pack_buffer(&buffer, mibAttribute->data, mibAttribute->length); /*lint !e545 !e725 unifi_DataBlock : mibAttribute */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_mib_get_next_req(uint8** resultBuffer, const unifi_DataBlock* mibAttribute)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    packedSize += mibAttribute->length + 2; /*lint !e725*/ /* unifi_DataBlock :: mibAttribute */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_MIB_GET_NEXT_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, mibAttribute->length); /*lint !e725 unifi_DataBlock : mibAttribute */
    packedLength += event_pack_buffer(&buffer, mibAttribute->data, mibAttribute->length); /*lint !e545 !e725 unifi_DataBlock : mibAttribute */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_scan_full_req(uint8** resultBuffer, const unifi_SSID* ssid, Boolean forceScan, unifi_ScanType scanType, const unifi_DataBlock* channelList)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 32;  ssid->ssid */
    /* packedSize += 1;  ssid->length */
    /* packedSize += 2;  forceScan */
    /* packedSize += 2;  scanType */
    packedSize += channelList->length + 2; /*lint !e725*/ /* unifi_DataBlock :: channelList */
    packedSize += 37; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_SCAN_FULL_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_buffer(&buffer, (uint8*)&ssid->ssid, 32); /*lint !e545 !e725    ssid */
    packedLength += event_pack_buffer(&buffer, (uint8*)&ssid->length, 1); /*lint !e545 !e725    length */
    packedLength += event_pack_int16(&buffer, (int16)forceScan); /* forceScan */
    packedLength += event_pack_uint16(&buffer, (uint16)scanType); /* scanType */
    packedLength += event_pack_uint16(&buffer, channelList->length); /*lint !e725 unifi_DataBlock : channelList */
    packedLength += event_pack_buffer(&buffer, channelList->data, channelList->length); /*lint !e545 !e725 unifi_DataBlock : channelList */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_scan_results_get_req(uint8** resultBuffer)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_SCAN_RESULTS_GET_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_connect_req(uint8** resultBuffer, const unifi_ConnectionConfig* connectionConfig)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 32;  connectionConfig->ssid.ssid */
    /* packedSize += 1;  connectionConfig->ssid.length */
    /* packedSize += 6;  connectionConfig->bssid.data */
    /* packedSize += 2;  connectionConfig->bssType */
    /* packedSize += 2;  connectionConfig->privacyMode */
    /* packedSize += 2;  connectionConfig->authMode */
    /* packedSize += 2;  connectionConfig->encryptionMode */
    packedSize += connectionConfig->mlmeAssociateReqInformationElements.length + 2; /*lint !e725*/ /* unifi_DataBlock :: mlmeAssociateReqInformationElements */
    /* packedSize += 1;  connectionConfig->wmmQosInfo */
    /* packedSize += 1;  connectionConfig->adhocChannel */
    packedSize += 49; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_CONNECT_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_buffer(&buffer, (uint8*)&connectionConfig->ssid.ssid, 32); /*lint !e545 !e725    ssid */
    packedLength += event_pack_buffer(&buffer, (uint8*)&connectionConfig->ssid.length, 1); /*lint !e545 !e725    length */
    packedLength += event_pack_buffer(&buffer, (uint8*)&connectionConfig->bssid.data, 6); /*lint !e545 !e725    data */
    packedLength += event_pack_uint16(&buffer, (uint16)connectionConfig->bssType); /* bssType */
    packedLength += event_pack_uint16(&buffer, (uint16)connectionConfig->privacyMode); /* privacyMode */
    packedLength += event_pack_uint16(&buffer, (uint16)connectionConfig->authMode); /* authMode */
    packedLength += event_pack_uint16(&buffer, (uint16)connectionConfig->encryptionMode); /* encryptionMode */
    packedLength += event_pack_uint16(&buffer, connectionConfig->mlmeAssociateReqInformationElements.length); /*lint !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
    packedLength += event_pack_buffer(&buffer, connectionConfig->mlmeAssociateReqInformationElements.data, connectionConfig->mlmeAssociateReqInformationElements.length); /*lint !e545 !e725 unifi_DataBlock : mlmeAssociateReqInformationElements */
    packedLength += event_pack_buffer(&buffer, (uint8*)&connectionConfig->wmmQosInfo, 1); /*lint !e545 !e725    wmmQosInfo */
    packedLength += event_pack_buffer(&buffer, (uint8*)&connectionConfig->adhocChannel, 1); /*lint !e545 !e725    adhocChannel */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_disconnect_req(uint8** resultBuffer)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_DISCONNECT_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_multicast_address_req(uint8** resultBuffer, unifi_ListAction action, const unifi_MulticastAddressList* setAddresses)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  action */
    /* packedSize += 1;  setAddresses->numElements */
    {
    int i;
    for (i = 0; i < setAddresses->numElements; i++)
    {
        /* packedSize += 6;  setAddresses->addresses[i].data */
        packedSize += 6;
    }
    }
    packedSize += 3; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_MULTICAST_ADDRESS_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)action); /* action */
    packedLength += event_pack_buffer(&buffer, (uint8*)&setAddresses->numElements, 1); /*lint !e545 !e725    numElements */
    {
    int i;
    for (i = 0; i < setAddresses->numElements; i++)
    {
        packedLength += event_pack_buffer(&buffer, (uint8*)&setAddresses->addresses[i].data, 6); /*lint !e545 !e725    data */
    }
    }
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_pmkid_req(uint8** resultBuffer, unifi_ListAction action, const unifi_PmkidList* setPmkidList)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  action */
    /* packedSize += 1;  setPmkidList->numElements */
    {
    int i;
    for (i = 0; i < setPmkidList->numElements; i++)
    {
        /* packedSize += 6;  setPmkidList->pmkids[i].bssid.data */
        /* packedSize += 16;  setPmkidList->pmkids[i].pmkid */
        packedSize += 22;
    }
    }
    packedSize += 3; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_PMKID_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)action); /* action */
    packedLength += event_pack_buffer(&buffer, (uint8*)&setPmkidList->numElements, 1); /*lint !e545 !e725    numElements */
    {
    int i;
    for (i = 0; i < setPmkidList->numElements; i++)
    {
        packedLength += event_pack_buffer(&buffer, (uint8*)&setPmkidList->pmkids[i].bssid.data, 6); /*lint !e545 !e725    data */
        packedLength += event_pack_buffer(&buffer, (uint8*)&setPmkidList->pmkids[i].pmkid, 16); /*lint !e545 !e725    pmkid */
    }
    }
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_key_req(uint8** resultBuffer, unifi_ListAction action, const unifi_Key* key)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  action */
    /* packedSize += 2;  key->keyType */
    /* packedSize += 1;  key->keyIndex */
    /* packedSize += 2;  key->wepTxKey */
    /* packedSize += 8;  key->keyRsc.data */
    /* packedSize += 2;  key->authenticator */
    /* packedSize += 6;  key->address.data */
    /* packedSize += 1;  key->keyLength */
    /* packedSize += 32;  key->key */
    packedSize += 56; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_KEY_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)action); /* action */
    packedLength += event_pack_uint16(&buffer, (uint16)key->keyType); /* keyType */
    packedLength += event_pack_buffer(&buffer, (uint8*)&key->keyIndex, 1); /*lint !e545 !e725    keyIndex */
    packedLength += event_pack_int16(&buffer, (int16)key->wepTxKey); /* wepTxKey */
    packedLength += event_pack_buffer(&buffer, (uint8*)&key->keyRsc.data, 8); /*lint !e545 !e725    data */
    packedLength += event_pack_int16(&buffer, (int16)key->authenticator); /* authenticator */
    packedLength += event_pack_buffer(&buffer, (uint8*)&key->address.data, 6); /*lint !e545 !e725    data */
    packedLength += event_pack_buffer(&buffer, (uint8*)&key->keyLength, 1); /*lint !e545 !e725    keyLength */
    packedLength += event_pack_buffer(&buffer, (uint8*)&key->key, 32); /*lint !e545 !e725    key */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_packet_filter_set_req(uint8** resultBuffer, const unifi_DataBlock* filter, unifi_PacketFilterMode mode, unifi_IPV4Address arpFilterAddress)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    packedSize += filter->length + 2; /*lint !e725*/ /* unifi_DataBlock :: filter */
    /* packedSize += 2;  mode */
    /* packedSize += 4;  arpFilterAddress */
    packedSize += 6; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_PACKET_FILTER_SET_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, filter->length); /*lint !e725 unifi_DataBlock : filter */
    packedLength += event_pack_buffer(&buffer, filter->data, filter->length); /*lint !e545 !e725 unifi_DataBlock : filter */
    packedLength += event_pack_uint16(&buffer, (uint16)mode); /* mode */
    packedLength += event_pack_uint32(&buffer, (uint32)arpFilterAddress); /* arpFilterAddress */
    *resultBuffer = evt;
    return packedLength;
}

uint16 build_packed_unifi_mgt_tspec_req(uint8** resultBuffer, unifi_ListAction action, uint32 transactionId, Boolean strict, const unifi_DataBlock* tspec, const unifi_DataBlock* tclas)
{
    uint16 packedLength = 0;
    uint16 packedSize = 6;
    uint8* evt;
    uint8* buffer;
    /* packedSize += 2;  action */
    /* packedSize += 4;  transactionId */
    /* packedSize += 2;  strict */
    packedSize += tspec->length + 2; /*lint !e725*/ /* unifi_DataBlock :: tspec */
    packedSize += tclas->length + 2; /*lint !e725*/ /* unifi_DataBlock :: tclas */
    packedSize += 8; /* Size of Fixed elements */
    evt = (uint8*)osa_malloc(packedSize);
    buffer = evt;
    packedLength += event_pack_uint16(&buffer, UNIFI_MGT_TSPEC_REQ_ID);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, 0);
    packedLength += event_pack_uint16(&buffer, (uint16)action); /* action */
    packedLength += event_pack_uint32(&buffer, (uint32)transactionId); /* transactionId */
    packedLength += event_pack_int16(&buffer, (int16)strict); /* strict */
    packedLength += event_pack_uint16(&buffer, tspec->length); /*lint !e725 unifi_DataBlock : tspec */
    packedLength += event_pack_buffer(&buffer, tspec->data, tspec->length); /*lint !e545 !e725 unifi_DataBlock : tspec */
    packedLength += event_pack_uint16(&buffer, tclas->length); /*lint !e725 unifi_DataBlock : tclas */
    packedLength += event_pack_buffer(&buffer, tclas->data, tclas->length); /*lint !e545 !e725 unifi_DataBlock : tclas */
    *resultBuffer = evt;
    return packedLength;
}

